translateapp/accounts/urls.py
from django.urls import path
from . import views

app_name = "accounts"

urlpatterns = [
        path('dashboard', views.dashboard, name="dashboard"),
        path('profile/<int:user_id>', views.profile, name="profile"),
        path('register', views.register, name="register"),
]

translateapp/app/urls.py
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
        path('jobs', views.jobs_index, name="jobs"),
        path('jobs/new', views.new_job, name="new_job"),
        path('jobs/<int:job_id>', views.job_detail, name="job_detail"),
        path('jobs/<int:job_id>/bid', views.bid, name="bid"),
        path('bids/<int:bid_id>/accept', views.accept_bid, name="accept_bid"),
        path('bids/<int:bid_id>/deliver', views.deliver_translation, name="deliver_translation"),
        path('bids/<int:bid_id>', views.bid_detail, name="bid_detail"),
        path('bids/<int:bid_id>/rating', views.rate_bid, name="rate_bid"),
        path('bids/<int:bid_id>/dispute', views.raise_dispute, name="dispute"),
        path('message/<int:receiver_id>', views.send_message, name="send_message"),
]

translateapp/messenger/urls.py
from django.urls import path, include

from . import views

app_name = "messenger"

urlpatterns = [
    path('', views.messenger, name="messenger"),
    path('<int:user_id>', views.thread, name="thread"),
]

translateapp/translateapp/urls.py
from django.contrib import admin
from django.urls import path, include

from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('app/', include('app.urls')),
    path('messenger/', include('messenger.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

translateapp/app/models.py
from django.db import models

from django.contrib.auth.models import User
from django.db.models import Q

class Account(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100)
    balance = models.DecimalField(max_digits=8, decimal_places=2, default=0)
    translator = models.BooleanField()
    def __str__(self):
        return f"{self.id} - {self.name}"

    def rating(self):
        ratings = Rating.objects.filter(rated=self.user)
        if ratings.count() == 0:
            return "No ratings yet"
        else:
            score = [ rating.rating for rating in ratings ]
            return sum(score) / len(score)

    def raise_if_invalid_balance(self):
        if self.balance < 0:
            raise ValueError("Balance cannot be negative")

    def active_jobs(self):
        return self.user.job_set.exclude(status='completed')

    def completed_jobs(self):
        return self.user.job_set.filter(status='completed')

class Job(models.Model):
    class Status(models.TextChoices):
        AVAILABLE = 'available', "Available"
        ASSIGNED = 'assigned', "Assigned"
        IN_PROGRESS = 'in_progress', "In Progress"
        COMPLETED = 'completed', "Completed"

    class Field(models.TextChoices):
        ART = 'art', "Art"
        BUS = 'business', "Business"
        COMP = 'computers', "Computers"
        EDU = 'education', "Education"
        ENG = 'engineering', "Engineering"
        FIN = 'finance', "Finance"
        LAW = 'law', "Law"
        LIT = 'literature', "Literature"
        MED = 'medicine', "Medicine"
        SCI = 'science', "Science"
        SOC = 'social_sciences', "Social Sciences"
        TECH = 'technology', "Technology"

    class Language(models.TextChoices):
        ENG = 'en', "English"
        SPA = 'spa', "Spanish"
        FRE = 'fr', "French"
        GER = 'de', "German"
        ITA = 'it', "Italian"
        JPN = 'ja', "Japanese"
        CRO = 'hr', "Croatian"

    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title = models.CharField(max_length=256)
    description = models.CharField(max_length=512)
    source_lang = models.CharField(
            max_length=3, 
            choices=Language.choices,
            default=Language.ENG,
    )
    target_lang = models.CharField(
            max_length=3,
            choices=Language.choices,
            default=Language.CRO,
    )
    field = models.CharField(
            max_length=100,
            choices=Field.choices,
            default=Field.ENG,
    )
    budget = models.DecimalField(max_digits=8, decimal_places=2)
    text = models.TextField()
    status = models.CharField(
            max_length=100, 
            choices=Status.choices,
            default=Status.AVAILABLE,
    )
    translation = models.TextField(blank=True, null=True)
    def __str__(self):
        return f"{self.user.account.name} - {self.title}"

    def accepted_bid(self):
        return self.bid_set.filter(accepted=True).first()

    def accepted_bidder(self):
        return self.accepted_bid().bidder.account

    def owner(self):
        return self.user.account

    # Helper method to check if the job is available, since checking the status
    # directly from the template is not very readable.
    def is_available(self):
        return self.status == self.Status.AVAILABLE

    def is_completed(self):
        return self.status == self.Status.COMPLETED

    def ordered_bids(self):
        return self.bid_set.order_by('-accepted')

    def bid_by_user(self, user):
        return self.bid_set.filter(bidder=user).first()

    def can_bid(self, user):
        # If user didn't bid already on the job and is not the job owner
        return self.bid_by_user(user) is None and self.user != user


    @classmethod
    def accepted_jobs_for(cls, user):
        # Svi bidovi gdje je user napravio job na koji je biddano
        accepted_bids = Bid.objects.filter(job__in=user.job_set.all(), accepted=True)
        # Svi jobovi gdje je user napravio job i bidano je na job 
        accepted_jobs = [ bid.job for bid in accepted_bids if bid.job.status != "completed" ]
        return accepted_jobs

class Bid(models.Model):
    bidder = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    price = models.DecimalField(max_digits=8, decimal_places=2)
    accepted = models.BooleanField(default=False)
    completed = models.BooleanField(default=False)
    def __str__(self):
        return f"{self.bidder.account.name} - {self.job.title} - {self.price}"
    def job_owner(self):
        return self.job.user

class Dispute(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    reason = models.TextField(blank=False, null=False)

class Message(models.Model):
    sender = models.ForeignKey(User, on_delete=models.CASCADE, related_name='sender')
    receiver = models.ForeignKey(User, on_delete=models.CASCADE, related_name='receiver')
    text = models.TextField(blank=False, null=False)
    sent_at = models.DateTimeField(auto_now_add=True)
    def __str__(self):
        return f"{self.sender.account.name} - {self.receiver.account.name} - {self.text[:20]}"
    
    def text_snippet(self):
        return f"{self.text[:30]}..."

    @classmethod
    def get_thread(cls, user1, user2):
        return cls.objects.filter(sender__in=[user1, user2], receiver__in=[user1, user2]).order_by('sent_at')

    @classmethod
    def get_thread_users(cls, user):
        # Using Q objects
        #https://docs.djangoproject.com/en/4.1/topics/db/queries/#complex-lookups-with-q-objects
        
        messages = Message.objects.filter(Q(sender=user) | Q(receiver=user)).order_by('-sent_at')
        ordered_users = []
        for message in messages:
            if message.sender != user and message.sender not in ordered_users:
                ordered_users.append(message.sender)
            if message.receiver != user and message.receiver not in ordered_users:
                ordered_users.append(message.receiver)

        return ordered_users

    @classmethod
    def get_threads_for(cls, my_user):
        users = cls.get_thread_users(my_user)
        threads = [ [user, cls.get_thread(my_user, user)] for user in users ]
        return threads

class Rating(models.Model):
    rater = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rater')
    rated = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rated')
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    rating = models.IntegerField()

translateapp/app/templates/app/base.html
<!DOCTYPE html>
{% load static %}
<html>
  <head>
    <title>Translate-o-Rama {% if user %} [{{ user.username }}] {% endif %}</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="{% static 'app/css/app.css' %}">
  </head>

  <body>
    <nav class="navbar navbar-expand-lg">
      <div class="container-fluid  p-2 ms-4 me-4">
          <a class="navbar-brand" href="/"><img class="logo" src="../../static/app/images/logo.png"></a> <!--stavit mu logo-->
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarText" aria-controls="navbarText" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarText">
            
            <ul class="navbar-nav me-auto mb-2 mb-lg-0">

              <li class="nav-item active">
                <a class="nav-link" href="/">Home</a>
              </li>

              {% if user.is_authenticated %}
                <li class="nav-item">
                    <a class="nav-link" aria-current="page" href="{% url 'app:new_job'  %}">Submit new job</a>
                </li>
                {% if user.account.translator %}
                  <li class="nav-item">
                  <a class="nav-link" href="{% url 'app:jobs' %}">See available jobs</a>
                  </li>
                {% endif %}
                <li class="nav-item">
                    <a class="nav-link" aria-current="page" href="{% url 'messenger:messenger'  %}">Messenger</a>
                </li>
              {% endif %}
            </ul>
            
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">

              {% if user.is_authenticated %}
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:profile' user.id %}">My profile</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:dashboard' %}">{{ user.account.name }}</a>
                </li>
                {% if user.is_superuser  %}
                  <li class="nav-item">
                    <a class="nav-link" href="/admin">Admin dashboard</a>
                  </li>
                {% endif %}
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                </li>
              {% else %}
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:register' %}">Register</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'login' %}">Login</a>
                </li>
              {% endif %}

            </ul>
          </div>
      </div>
    </nav>

    <div class="content container">
      <div class="row">
        {% if error %}
          <div class="col-md-12">
            <div class="alert alert-danger" role="alert">
              {{ error }}
            </div>
          </div>
        {% endif %}
        {% if message %}
          <div class="alert alert-success" role="alert">
            {{ message }}
          </div>
        {% endif %}
        <div class="col-md-12 no-padding">
          {% block content %}
          {% endblock %}
        </div>
      </div>
    </div>
  </body>
</html>

translateapp/app/templates/app/bid_detail.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
<div class="container">
  <div class="row">
    <div class="col-md-6">
      <h1 class="mb-5 mt-5">Translation completed!</h1>
      
      <p class="h5"> 
        Bid from <a href="{% url 'accounts:profile' bid.bidder.id %}">{{ bid.bidder.account.name }}</a>
        for a job from <a href="{% url 'accounts:profile' job.user.id %}">{{ job.user.account.name }}</a>
      </p> 
      <div class="my-4">
        <p class="mb-2 fw-bold h5">{{ job.title }}</p>
        <p>{{ job.description }}</p>
        
        <p> Job budget: {{ job.budget }} </p>
        <p> Bid amount: {{ bid.price }} </p>
      </div>
    </div>
    <div class="col-md-6">
      <h1 class="mb-5 mt-5">Rating details</h1>
      {% if bid.rating  %}
        <!--if job is completed and rating exists -->
        {% if user == bid.bidder %}
          <h2>You were rated: {{ bid.rating.rating }}</h2>
        {% elif user == bid.job.user %}
          <h2>You rated this job: {{ bid.rating.rating }}</h2>
        {% endif %}
      {% elif bid.dispute  %}
        <!--if job is completed and rating exists -->
        {% if user == bid.bidder %}
          <h2>Your job got disputed!</h2>
          <p>Waiting for an admin to resolve...</p>
          <blockquote class="blockquote">
            {{ bid.dispute.reason }}
          </blockquote>
        {% elif user == bid.job.user %}
          <h2>You disputed this job!</h2>
          <blockquote class="blockquote">
            {{ bid.dispute.reason }}
          </blockquote>
        {% endif %}
      {% else %}
        <!--we are still waiting for the job owner to rate the translation -->
        {% if user == bid.bidder %}
          <h2>Waiting for the rating from the Job owner</h2>
        {% elif user == bid.job.user %}
          <h2>Rate the translation!</h2>

          <form action="{% url 'app:rate_bid' bid.id %}" method="post">
            {% csrf_token %}
            <input type="submit" value="1" name="rating" class="btn custom-btn2">
            <input type="submit" value="2" name="rating" class="btn custom-btn2">
            <input type="submit" value="3" name="rating" class="btn custom-btn2">
            <input type="submit" value="4" name="rating" class="btn custom-btn2">
            <input type="submit" value="5" name="rating" class="btn custom-btn2">
          </form>
          <p>Or raise a dispute if you're not satisfied</p>

          <form action="{% url 'app:dispute' bid.id %}" method="post">
            {% csrf_token %}

            {% for field in form.visible_fields %}
              <div class="form-group">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {{ field|add_class:'form-control' }}
                {% for error in field.errors %}
                  <span class="help-block">{{ error }}</span>
                {% endfor %}
              </div>
            {% endfor %}

            <div class="form-group">
              <button type="submit" class="btn btn-danger my-3 px-4">
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-check-lg" viewBox="0 0 16 16">
                  <path d="M12.736 3.97a.733.733 0 0 1 1.047 0c.286.289.29.756.01 1.05L7.88 12.01a.733.733 0 0 1-1.065.02L3.217 8.384a.757.757 0 0 1 0-1.06.733.733 0 0 1 1.047 0l3.052 3.093 5.4-6.425a.247.247 0 0 1 .02-.022Z"/>
                </svg> Start a Dispute
              </button>
            </div>
          </form>
        {% endif %}
      {% endif %}
    </div>
    <div class="col-md-6">
      <h5>Original text:</h5>
      <p class="with-whitespace">
        {{ job.text }}
      </p>
    </div>
    <div class="col-md-6">
      <h5>Translated text: </h5>
      <p class="with-whitespace">
        {{ job.translation }}
      </p>
    </div>
    
  </div>
</div>



{% endblock %}

translateapp/app/templates/app/deliver_translation.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <h1 class="mb-5 mt-5">Submit your translation</h1>
  <form method="post">
    {% csrf_token %}

    {% for hidden in form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          {% for field in form.visible_fields %}
            <div class="form-group">
              <label for="{{ field.id_for_label }}">{{ field.label }}</label>
              {{ field|add_class:'form-control' }}
              {% for error in field.errors %}
                <span class="help-block">{{ error }}</span>
              {% endfor %}
            </div>
          {% endfor %}

          <div class="form-group">
            <button type="submit" class="btn custom-btn my-3 px-4">
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-check-lg" viewBox="0 0 16 16">
                <path d="M12.736 3.97a.733.733 0 0 1 1.047 0c.286.289.29.756.01 1.05L7.88 12.01a.733.733 0 0 1-1.065.02L3.217 8.384a.757.757 0 0 1 0-1.06.733.733 0 0 1 1.047 0l3.052 3.093 5.4-6.425a.247.247 0 0 1 .02-.022Z"/>
              </svg> Submit
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default">Cancel</a>
          </div>
        </div>
      </div>
    </div>
    

  </form>
{% endblock %}

translateapp/app/templates/app/home.html
{% extends 'app/base.html' %}
{% block content %}

<div class="content container">
    <div class="row">
      <div class="col-md-12">
          <div class="p-3 mb-4 rounded-3  jumbotron-container">
              <div class="container-fluid py-4">
                  <h1 class="display-5 fw-bold">Translate-o-Rama</h1>
                  <p class="col-md-8 fs-4">Web application that enables users to hire translators to translate their texts quickly and conveniently.</p>
              </div>
          </div>
      </div>
    </div>
</div>

<p class="ms-5">Translate your texts in a jiffy</p>

{% endblock content %}

translateapp/app/templates/app/jobs_detail.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
<h1 class="mb-5 mt-5">{{ job.title }}</h1>
<h4>{{ job.description }}</h4>
<div class="container">
  <div class="row">
    <div class="col-md-8 mt-4">
      <p class="mt-4 h5">Job details:</p>
      <p>
        <ul>
          <!--source_lang, target_lang, field, budget, owner, text, -->
          <li>From {{ job.get_source_lang_display }} to {{ job.get_target_lang_display }}</li>
          <li>Field: {{ job.get_field_display }}</li>
          <li>Budget: {{ job.budget }}</li>
          <li>Owner: {{ job.owner }}</li>
        </ul>
      </p>
    </div>
    <div class="col-md-4 mt-5">
      {% if my_bid %}
        <h3>You already bid on this job.</h3>
        <p class="ms-1">Your bid: <strong>{{ my_bid.price }}</strong></p>
      {% elif job.user == user %}
        <h3>This is your job.</h3>
      {% else %}
        <h3>Enter your bid:</h3>
        <form action="{% url 'app:bid' job.id %}" method="post" >
          {% csrf_token %}
          <div class="form-group">
            <label for="{{ form.price.id_for_label }}">Price</label>
            {{ form.price|add_class:'form-control' }}

            {% for error in form.price.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>
          <button type="submit" class="btn custom-btn mt-4">Submit</button>
        </form>
      {% endif %}
    </div>
  </div>
</div>
<p class="with-whitespace mb-4">
  <strong class="h5">Text:</strong></br>
  {{ job.text }}
</p>

{% endblock content %}

translateapp/app/templates/app/jobs_index.html
{% extends 'app/base.html' %}


{% block content %}
<h1 class="mb-5 mt-5">Available jobs</h1>

<form action="{% url 'app:jobs' %}" method="get">
  <div class="container">
    <div class="row mb-3">
      <div class="col-md-3">filter here</div>
      <div class="col-md-3">filter here</div>
      <div class="col-md-3">
        <div class="form-group ">
          <label for="target_lang">Target Language</label>
          <select class="form-control" id="target_lang" name="target_lang">
            <option value="">Any language</option>
            {% for code, lang in languages  %}
              <option value="{{ lang }}" {% if params.target_lang == lang %} selected {% endif %}>{{ lang }}</option>
            {% endfor %}
          </select>
        </div>
      </div>
      <div class="col-md-3">
        <div class="form-group ">
          <label for="sort">Sort by</label>
          <select class="form-control" id="sort" name="sort">
            <!-- params.sort is the value of the sort query parameter -->
            <!-- it is passed in the context from the view -->
            <!-- if the value of the sort query parameter is equal to the value of the option, then we add the selected attribute -->
            <option value="default" {% if params.sort == "default" %} selected {% endif %}>Default</option>
            <option value="budget_asc" {% if params.sort == "budget_asc" %} selected {% endif %}>Budget Asc</option>
            <option value="budget_desc" {% if params.sort == "budget_desc" %} selected {% endif %}>Budget Desc</option>
          </select>
        </div>
      </div>
      <div class="col-md-12">
        <!-- submit button -->
        <div class="form-group">
          <button type="submit" class="btn custom-btn mt-4">Filter</button>
        </div>
      </div>
    </div>
  </div>
</form>

<table class="table table-bordered custom-table">
  {% for job, my_bid in jobs %}
      <tr class="{% if my_bid %} placed-bid {% endif %}">
        <td>
          <strong>
            <a href="{% url 'app:job_detail' job.id %}">{{ job.title }}</a>
          </strong>
        </td>
        <td>
          <a href="{% url 'accounts:profile' job.user.id %}">
            {{ job.owner.name }}
          </a>
        </td>
        <!--https://stackoverflow.com/a/6127466/347891-->
        <td>{{ job.get_source_lang_display }} to {{ job.get_target_lang_display }} </td>
        <td>Budget: {{ job.budget }}</td>
      </tr>
      <tr class="{% if my_bid %} placed-bid {% endif %}">
        <td colspan="3">
          {{ job.description }}
        </td>
        <td>
          {{ job.get_field_display }}
        </td>
      </tr>
      <tr class="{% if my_bid %} placed-bid {% endif %}">
        {% if my_bid is None and job.user != request.user %}
          <td colspan="4" class="bid-controls-row">
            <a href="{% url 'app:job_detail' job.id %}" class="btn custom-btn ms-2 mt-2 mb-5">Submit a quote</a>
            <a href="{% url 'app:send_message' job.user.id %}" class="btn custom-btn2 ms-3 mt-2 mb-5">Message Job Owner</a>
          </td>
        {% elif my_bid  %}
          <td colspan="4"><p>You already placed a bid for <strong>{{ my_bid.price }}</strong></p></td>
        {% elif job.user == request.user  %}
          <td colspan="4"><p>This is your job!</p></td>
        {% endif %}
      </tr>
  {% empty %}
    <tr>
      <td colspan="4"> No available jobs at this moment</td>
    </tr>
  {% endfor %}
  </table>


{% endblock content %}

translateapp/app/templates/app/jobs_new.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <h1 class="mb-5 mt-5">Submit new job</h1>
  <form method="post">
    {% csrf_token %}

    {% for hidden in form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          {% for field in form.visible_fields %}
            {% if field.label != "Text" %}
              <div class="form-group mt-3">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {{ field|add_class:'form-control' }}
                {% for error in field.errors %}
                  <span class="help-block">{{ error }}</span>
                {% endfor %}
              </div>
            {% endif %}
          {% endfor %}

          <div class="form-group mt-4 mb-5">
            <button type="submit" class="btn custom-btn px-4 ">
              <span class="glyphicon glyphicon-ok"></span> Save
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default">Cancel</a>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group mt-3">
            <label for="{{ form.text.id_for_label }}">{{ form.text.label }}</label>
            {{ form.text|add_class:'form-control' }}
            {% for error in form.text.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>
        </div>
      </div>
    </div>
    

  </form>
{% endblock %}

translateapp/app/templates/app/send_message.html
{% extends 'app/base.html' %} {% block content %}

<div class="mt-5">
  <h1>Send message</h1>

  <form
    action="{% url 'app:send_message' receiver.id %}"
    method="post"
    accept-charset="utf-8"
  >
    {% csrf_token %}

    <div class="row m-4">
      <label for="text" class="mb-2 fs-5"> Text </label>
      <textarea
        name="text"
        id="text"
        cols="30"
        rows="10"
        style="resize: none"
        class="col-4"
      ></textarea>
    </div>

    <input
      type="submit"
      value="Send"
      class="btn custom-btn ms-4 mt-2 py-2 px-4"
    />
  </form>
</div>

{% endblock content %}